/****************************************************************************
** Copyright (C) 2006 Koh Yeow Nam, Geoffrey
** All rights reserved
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Filename: maxproductpropagator_test.h
**  
** Description:
** The header file storing all the specification for a test file for the simple max product belief propagation.
**  
** Last modified: 
** 06 December 2006
** 
** Comments:
****************************************************************************/

#ifndef MAXPRODUCTPROPAGATOR_TEST_H_
#define MAXPRODUCTPROPAGATOR_TEST_H_

#include <iostream>
#include "maxproductpropagator.h"
#include "factorgraph.h"
#include "discretedistribution.h"

void testMaxProductPropagator_SimplePathway();

double samplef1(double x1_dot, double x1, double k1, double k2);
double samplef2(double x2_dot, double x1, double x2, double k2, double k3, double k4);
double samplef3(double x3_dot, double x2, double x3, double k3, double k5);
double samplef4(double x4_dot, double x2, double x4, double k4, double k6);

string itos(int i);

#endif

