/****************************************************************************
** Copyright (C) 2006 Koh Yeow Nam, Geoffrey
** All rights reserved
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Filename: odeparser.h
**  
** Description:
** This is the implementation of an equation parser for an ODE.
**
** Last modified: 
** 16 February 2007
** 
** Comments:
**
****************************************************************************/

#ifndef ODEPARSER_H_
#define ODEPARSER_H_

/* For debugging. Comment out to suppress debugging lines */
#define ODEPARSER_DEBUG

/* Standard Includes */
#include <iostream>
#include <vector>

/* Application Includes */
#include "odecommon.h"
#include "odenode.h"
#include "odetokenizer.h"

using namespace std;

namespace ode {

/* Forward Declarations */
class ODENode;

class ODEParser {

public:

	/* Constructors and destructors */
	ODEParser();
	virtual ~ODEParser();

	ODENode* parse(string expression);
	void clear();
	
protected:

	vector<ODENode*> mStack;
	vector<string> mOpStack;

};

}

#endif /* ODEPARSER_H_ */
