/****************************************************************************
** Copyright (C) 2006 Koh Yeow Nam, Geoffrey
** All rights reserved
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Filename: random_test.cpp
**  
** Description:
** The test file for the random number generators
**  
** Last modified: 
** 26 March 2007
** 
** Comments:
****************************************************************************/

/* Standard Includes */
#include <iostream>

/* APplication Includes */
#include "random.h"
#include "random_test.h"

using namespace std;
using namespace random;

/** Main function to call for the test of discretize domain
**/
void testRandom() {

	cout << "===============" << endl;
	cout << "In testRandom()" << endl;
	cout << "===============" << endl;

	// Test the gaussian number generator
	testGaussian();
}

/** Test the uniform number generator
**/
void testMersenneTwister() {
	// Do nothing
}

/** Test the gaussian distribution
**/
void testGaussian() {

	cout << "=================" << endl;
	cout << "In testGaussian()" << endl;
	cout << "=================" << endl;

	Gaussian::init(time(NULL));
	
	cout << "Test 1: Generating a random number 100 times" << endl;
	for (int i = 0; i < 10000; i++) {
		cout << Gaussian::rand() << endl;
	}
	
}
