/****************************************************************************
** Copyright (C) 2006 Koh Yeow Nam, Geoffrey
** All rights reserved
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Filename: common.h
**  
** Description:
** Provides the commonly used functionalities
**
** Last modified: 
** 12 March 2009
** 
** Comments:
****************************************************************************/

#ifndef COMMON_H_
#define COMMON_H_

/* Standard Includes */
#include <iostream>
#include <vector>

/* Application Includes */
#include "ode.h"

using namespace ode;

struct datapoint {
	int timeIndex;
	int variableIndex;
	double value;
	double weight;
};

static unsigned long duration;

vector<datapoint> getDataPoints(const vector<double>& timeList, 
							    const vector<string>& variableList, 
								const vector<double>& weightList,
								const ODETrace& trace);

double score(const vector<datapoint>& pointList, const ODETrace& trace);

string itos(int i);

// These three are used in conjunction to start/stop and time the runs
void timeStart();
void timeStop();
string timeTaken();

#endif
