/****************************************************************************
** Copyright (C) 2006 Koh Yeow Nam, Geoffrey
** All rights reserved
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** Filename: model1.h
**  
** Description:
**
** Last modified: 
** 24 April 2007
** 
** Comments:
****************************************************************************/

#ifndef MODEL1_H_
#define MODEL1_H_

/* Standard Includes */
#include <iostream>
#include <vector>

/* Application Includes */
#include "common.h"
#include "ode.h"
#include "beliefpropagation.h"

using namespace std;
using namespace ode;
using namespace factorgraph;

namespace model1 {

// Creates the model, trace and factor graph
ODESystem* createModel();
ODETrace* createTrace(const vector<double>& p, const vector<double>& y, ODESystem& model);
ODETrace* createNominalTrace();
FactorGraph* createFactorGraph();

// Predefined functions for getting the nominal parameters, variables and the weight list
vector<double> getParameters();
vector<double> getVariables();
vector<double> getWeights();

// The actual belief propagation code
void runPropagate();
void runModel();

}

#endif
